#include <stdio.h>
#include <ctype.h>

#include <windows.h>
#include <shellapi.h>

void dump_print(FILE *infp, FILE *outfp, long from, long size);
int IsKana(int c);
int Is1stByte(int c);
int Is2ndByte(int c);

int main(int argc, char *argv[]){
	int i;
	long file_size;
	FILE *infp, *outfp;
	char file_name[FILENAME_MAX];
	const int dump_size = 16 * 24;
	
	if (argc < 2){
		return 1;
	}
	
	if((infp = fopen(argv[1], "rb")) == NULL){
		return 1;
	}
	
	if(fseek(infp, 0, SEEK_END) != 0){
		return 1;
	}
	
	strcpy(file_name, argv[0]);
	for(i = strlen(file_name); i != -1; i--){
		if(file_name[i] == '\\'){
			file_name[i + 1] = '\0';
			break;
		}
	}
	strcat(file_name, "dump.txt");
	
	if((outfp = fopen(file_name, "w")) == NULL){
		return 1;
	}
	
	fprintf(outfp, "%s\n\n", argv[1]);
	
	file_size = ftell(infp);
	
	if(file_size < dump_size * 2){
		dump_print(infp, outfp, 0, file_size - 1);
	} else {
		dump_print(infp, outfp, 0, dump_size);
		fprintf(outfp, "\n");
		dump_print(infp, outfp, file_size - dump_size, file_size);
	}
	
	fclose(outfp);
	fclose(infp);
	
	ShellExecute(0, NULL, file_name, NULL, NULL, SW_SHOW);
	
	return 0;
}

int IsKana(int c){
  return ((c >= 0xA0) && (c <= 0xDF));
}

int Is1stByte(int c){
  return ((c >= 0x81) && (c <= 0x9F)) || ((c >= 0xE0) && (c <= 0xFF));
}

int Is2ndByte(int c){
  return ((c >= 0x40) && (c <= 0x7E)) || ((c >= 0x81) && (c <= 0xFC));
}

void dump_print(FILE *infp, FILE *outfp, long from, long size){
	int i, r, last;
	int v[17];
	
	r = from & 0xF;
	from -= r;
	size += r;
	
	fseek(infp, from, SEEK_SET);
	
	fprintf(outfp, "ADDRESS   00 01 02 03 04 05 06 07 08 09 0A 0B 0C 0D 0E 0F  0123456789ABCDEF\n");
	
	last = 0;
	v[16] = getc(infp);
	while((size > 0) && !feof(infp)){
		v[0] = v[16];
		for(i = 1; i < 17; i++){
			v[i] = getc(infp);
		}
		
		fprintf(outfp, "%08lX  ", from);
		for(i = 0; i < 16; i++){
			if(v[i] == -1){
				fprintf(outfp, "   ");
			} else {
				fprintf(outfp, "%02X ", v[i]);
			}
		}
		fprintf(outfp, " ");
		for(i = 0; i < 16; i++){
			if(last){
				fprintf(outfp, " ");
				last = 0;
				i++;
			}
			if(v[i] == -1){
				break;
			} else if(!isprint(v[i]) && !IsKana(v[i])){
				if (Is1stByte(v[i]) && Is2ndByte(v[i + 1])){
					fprintf(outfp, "%c%c", v[i], v[i + 1]);
					last = (i == 15);
					i++;
				} else {
					fprintf(outfp, ".");
				}
			} else {
				fprintf(outfp, "%c", v[i]);
			}
		}
		fprintf(outfp, "\n");
		size -= 16;
		from += 16;
	}
}
